/*
 * For more information on the NYTimes API, visit http://developer.nytimes.com/
 * Inspired by NYT processing example by Jer Thorp from
 * http://blog.blprnt.com/blog/blprnt/processing-json-the-new-york-times
 *
 * Date: 20160222
 * Revision: 0.1
 * Author: P.Peters
 */

//Base URL for the NYT Article Search API 
String baseURL = "http://api.nytimes.com/svc/search/v2/articlesearch.json";  
//Register and enter your API Key here (http://developer.nytimes.com/)
String apiKey = "b22f7f73925097ad43d63f65e8002bc5:16:74488051";
//Start Date
String startdate = "20160221";
//End Date
String enddate = "20160222";
// search terms
String[] words = {"usa"};
// result of search is put in here
String[] result;
// refresh indicates a new search should be done
boolean refresh = true; 
// display time of one item
int delay = 300;
// 
int itemCounter, displayedTime;
int txtsz = 60;
void setup() { 
  //Set the size of the stage & set the background
  //size(800, 300);
  textSize(txtsz);
  smooth();
}

void draw() {
  // chack if new search nust be done
  if (refresh) {
    // indicate search is done
    refresh = false;
    // do search
    result = getData(words[0], startdate, enddate);
    // reset diaplay item counter
    itemCounter=0; 
    displayedTime = 0;
  }

  if (displayedTime == 0) {
    // display new result
    background(0);
    if (result != null) println(result[itemCounter]);
    display(result[itemCounter]);
    displayedTime++;
  } else {
    if (displayedTime > 500) { // this manyframes is the time to display
      // reset display timer
      displayedTime = 0;
      // select next news item
      itemCounter++;
      // and loop around if maximum reached
      if (itemCounter >= result.length) itemCounter = 0;
    } else displayedTime++;
  }
}

// split text into lines that fit on the canvas and display
void display(String txt) {
  int pos = 0; // index in split text array
  int line = 0; // line counter
  String[] spl = split(txt, ' '); // split text into words
  String t = "";
  do {
    // add a word to the line in construction making sure it does not exceed te canvas width
    while ((pos < spl.length) && (textWidth(t+" "+spl[pos]) < width)) {
      t = t+" "+spl[pos];
      pos++;
    }
    // display the constructed line
    text(t, 10, height/2+txtsz+(line*txtsz));
    // increment line counter for vertical positioning
    line++;
    // and start a new text line
    t="";
  } while (pos < spl.length);
}

/*
 * getData
 *  Makes a request to the NYT Article Search API
 */

String[] getData(String word, String startdate, String enddate) {
  String url = baseURL + "?q=" + word + "&begin_date="+ startdate + "&end_date=" + enddate + "&api-key=" + apiKey;
  String info = join(loadStrings(url), "");

  try { 
    JSONObject nytData = JSONObject.parse(info); 
    JSONObject response = nytData.getJSONObject("response");
    JSONArray docs = response.getJSONArray("docs");
    //println(docs.size());
    String[] dta = new String[docs.size()];

    for (int i = 0; i < docs.size(); i++) {
      JSONObject o = docs.getJSONObject(i);
      dta[i] = o.getString("snippet");
      //println(dta[i]);
    };
    return dta;
  }  
  catch (Exception e) {  
    println (e.toString());  
    return null;
  }
}

void mouseClicked() {
  refresh = true;
}